﻿@model Charts.Models.ChartType
@{
    ViewBag.Title = "Index";
    Layout = "~/Views/Shared/ChartLayout.cshtml";
}

<!DOCTYPE html>
<html>
<head>
    <meta name="viewport" content="width=device-width" />
    <link href="~/Content/bootstrap.css" rel="stylesheet" />
    <script src="~/Scripts/jquery-3.4.1.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/Chart.js/2.6.0/Chart.min.js"></script>
    <title>Index</title>
    <style>
        .xdc {
            max-width: 70%;
            max-height: 70%;
        }

        .ctr {
            padding-left: 20%;
        }

        .ajax-loading {
            transition: all 0.3s;
            opacity: 0;
            z-index: -1;
        }

            .ajax-loading.active {
                opacity: 1;
                z-index: 100;
            }
    </style>
</head>
<body>
    <br />
    <h3 style="text-align:center">Chart Representation</h3>
    <div class="xdc" style="padding-left:20%;padding-top:20px">
        @Html.DropDownList("ChartName", null, "--Select Graph--", htmlAttributes: new { @class = "form-control", @id = "chartType" })
    </div>
    <br />
    <div class="container">

        <div class="ctr" >
            <img src="~/images/805.gif" id="img" alt="loading" />
        </div>
        <div id="chartID" class="xdc">
            <canvas id="myChart"></canvas>
        </div>


        

    </div>
</body>
</html>
@section Scripts {
    <script type="text/javascript">
        $(document).ready(function () {
            let massPopChart1;
            $("#img").hide();
            var count = 0;
            $("#chartType").change(function () {
                //hiding chart div
                count = count + 1;
                $("#chartID").hide();
                var value = $("#chartType").val();
                console.log(value);
                
                var urlString = "/Chart/chat";
                $.ajax({
                    method: 'Get',
                    url: urlString,
                    dataType: 'json',
                    contentType: "application/json",
                    beforeSend: function () {
                        // setting a timeout
                        if (count > 1) {
                            $("#img").show();
                        }
                        
                    },
                    success: function (data) {
                        $("#chartID").show();
                        let myChart = 'myChart';
                        // Global Options
                        Chart.defaults.global.defaultFontFamily = 'Lato';
                        Chart.defaults.global.defaultFontSize = 18;
                        Chart.defaults.global.defaultFontColor = '#777';
                        console.log(count);
                        if (count > 1) {
                            massPopChart1.destroy();
                        }                     
                        massPopChart1 = new Chart(myChart, {
                            type: value,
                            data: {
                                labels: data.Xaxis,
                                datasets: [{
                                    label: '',
                                    data: data.Y1axis,
                                    backgroundColor: data.color1,
                                    borderWidth: 1,
                                    borderColor: '#777',
                                    hoverBorderWidth: 3,
                                    hoverBorderColor: '#000'
                                }]
                            },
                            options: {
                                title: {
                                    display: true,
                                    text: 'Policy Count 2019',
                                    fontSize: 25
                                },
                                legend: {
                                    display: true,

                                    position: 'right',
                                    labels: {
                                        fontColor: '#000'
                                    }
                                },
                                layout: {
                                    padding: {
                                        left: 10,
                                        right: 0,
                                        bottom: 0,
                                        top: 0
                                    }
                                },
                                scales: {
                                    xAxes: [{
                                        stacked: true,
                                        ticks: {
                                            autoSkip: false
                                        }
                                    }],
                                    yAxes: [{
                                        stacked: true
                                    }]
                                },
                                tooltips: {
                                    enabled: true,
                                                                     
                                },
                            }                            
                        });
                        
                    },
                    
                    error: function () {
                        alert("something is wrong");
                    },
                    complete: function () {
                        $("#img").hide();
                     
                    }

                });
            })
        });
    </script>

}